/***********************************************************
	bernoull.c -- Bernoulli (xk[C) 
***********************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>

double gcd(double x, double y)  /* ő */
{
	double t;

	while (y != 0) {  t = fmod(x, y);  x = y;  y = t;  }
	return x;
}

#define  N 40

int main()
{
	int i, n;
	double q, b1, b2, bc, d;
	static double t[N + 1];
	char s[4] = " =  ";
	double invEP = 1 / DBL_EPSILON;

   /* B0 */
	n = 0;
	b1 = 1;
	printf(" B(%2d) =  %.0f\n", n, b1);
   /* B1 */
	n = 1;
//	b1 = -1;
	b2 = 2;
	printf(" B(%2d) =}%.0f/%.0f\n", n, b1, b2);
   /* B2` */
	q = 1;         /* ꏉl */
	t[1] = 1;      /* ql */
	for (n = 2; n <= N; n++) {
		for (i = 1; i < n; i++) t[i - 1] = i * t[i];            /* qvZ */
		t[n - 1] = 0;                                           /* 	V 		*/
		for (i = n; i >= 2; i--) t[i] += t[i - 2];              /* 	V 		*/
		if (n % 2 == 0) {                                      	/* nȂ */
			b1 = n * t[0];                                      /* qvZ */
			bc = b1;
			q *= 4;                                             /* vZ */
			b2 = q * (q - 1);                                   /* 	V 		*/
			if (n % 4 == 0) { b1 *= -1; s[3] = '\0';           	/* n4̔{̎ -b1 */
					} else s[3] = ' ';
		   /* L̔ */
			if (bc < invEP && b2 < invEP) {  				 	/*  */
				d = gcd(bc, b2);                              	/* d ő */
				b1 /= d;
				b2 /= d;
				printf(" B(%2d)%s%.0f/%.0f\n", n, s, b1, b2);  	/* \L */
			} else {                                           	/* L */
				printf(" B(%2d)%s%.10g\n", n, s, b1 / b2);     	/* _\L */
				}
		}
	}

	printf("\n EnterL[ĉ");
	getchar();
	return EXIT_SUCCESS;
}

