unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Buttons;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    BitBtn2: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses mp_real, mp_types, mp_base;

var
  EPSILON : extended;
  MP_EPSILON : mp_float;


// _̏]
function fmod(x, y: extended): extended;
var
  tmp: extended;
  n  : integer;
begin
  tmp := x / y;
  n := trunc(tmp);
  result := x - y * n;
end;

// ő [Nbȟݏ@
function gcd(x, y: extended): extended;
var
  t : extended;
begin
  while y <> 0 do begin
    t := fmod(x, y);
    x := y;
    y := t;
  end;
  result := x;
end;

// xk[CvZ ʐxvZ
// t[]͕q̒l
// q͕̒l
procedure TForm1.BitBtn1Click(Sender: TObject);
const
  N = 50;
var
  i, m : integer;
  q, b1, b2, d, invE: extended;
  t: array of extended;
  estr : string;
begin
  memo1.Clear;
  {$IFDEF CPUX64}                               // vbgtH[64rbg
  begin                                         // double vZx15
    memo1.Lines.Add('CPUX64[h Zx double');
  end;
  {$ENDIF CPUX64}
  {$IFDEF CPUX86}                               // vbgtH[32rbg
  begin                                         // extended vZx19
    memo1.Lines.Add('CPUX86[h Zx extended');
  end;
  {$ENDIF CPUX86}
  invE := 1 / EPSILON;                                   // _ _\ɂȂȂőll
// B0,B1
  m := 0;
  b1 := 1;
  memo1.lines.append('B' + inttostr(m) + ' =  ' + floatTostr(b1));
  m := 1;
  b1 := -1;
  b2 := 2;
  memo1.lines.append('B' + inttostr(m) + ' = ' + floatTostr(b1) + ' / ' + floatTostr(b2));
// B2`
  setlength(t, N + 1);                                   // zmہ@q̌vZɎgp zSă[
  q := 1;                                                // ꏉl
  t[1] := 1;                                             // ql
  for m := 2 to N do begin
    for i := 1 to m - 1 do t[i - 1] := i * t[i];         // qvZ
    t[m - 1] := 0;                                       // V
    for i := m downto 2 do t[i] := t[i] + t[i - 2];      // V
    if m mod 2 = 0 then begin                            // xk[CNoȂ
      b1 := m * t[0];                                    // q
      q := q * 4;                                        // vZ
      b2 := q * (q - 1);                                 // 
      if m mod 4 = 0 then begin                          // xk[C}CiXɂȂxk[CNo
        estr := ' = ';
        b1 := -b1;
      end
      else estr := ' =  ';
      if (abs(b1) < invE) and (b2 < invE) then begin     // 番\
        d := gcd(abs(b1), b2);                           // ő
        b1 := b1 / d;
        b2 := b2 / d;
        memo1.lines.append('B' + inttostr(m) + estr + floatTostr(b1) + ' / ' + floatTostr(b2));
      end
      else                                               // 珬_\
        memo1.lines.append('B' + inttostr(m) + estr + floatTostr(b1 / b2));
    end;
  end;
end;

//------------------------------------------------------------------------------

// _̏] {vZ
procedure Mp_fmod(x, y: mp_float; var ans: mp_float);
var
  tmp, tmp0: mp_float;
  n : mp_int;
begin
//  mpf_set_default_decprec(200);
  mpf_init2(tmp, tmp0);
  mp_init(n);

  mpf_div(x, y, tmp);
  mpf_trunc(tmp, n);
  mpf_mul_mpi(y, n, tmp0);
  mpf_sub(x, tmp0, ans);

  mp_clear(n);
  mpf_clear2(tmp, tmp0);
end;

// ő {vZ [Nbȟݏ@
procedure MP_gcd(a, b: mp_float; var ans: mp_float);
var
  t: mp_float;
  x, y: mp_float;
begin
//  mpf_set_default_decprec(200);
  mpf_init3(t, x, y);
  mpf_copy(a, x);           // a̒lςȂ悤ɃRs[Ďgp
  mpf_copy(b, y);           // b̒lςȂ悤ɃRs[Ďgp
  repeat
    Mp_fmod(x, y, t);
    mpf_copy(y, x);
    mpf_copy(t, y);
  until s_mpf_is0(y);
  mpf_copy(x, ans);
  mpf_clear3(t, x, y);
end;

// xk[CvZ {vZ
procedure TForm1.BitBtn2Click(Sender: TObject);
const
  N = 100;
var
  i, m : integer;
  q, b1, b2, d, tmp, invE: mp_float;
  t: array[0..N] of mp_float;
  estr : string;
begin
//  mpf_set_default_decprec(200);
  mpf_init5(q, b1, b2, d, tmp);
  mpf_init(invE);
  for i := 0 to N do mpf_init(t[i]);

  memo1.Clear;
  mpf_inv(MP_EPSILON, invE);
  m := 0;
  mpf_set1(b1);
  memo1.lines.append('B' + inttostr(m) + ' =  ' + string(mpf_decimal_alt(b1, 200)));
  m := 1;
  mpf_set_int(b2, 2);
  mpf_chs(b1, b1);
  memo1.lines.append('B' + inttostr(m) + ' = ' + string(mpf_decimal_alt(b1, 200))
                                       + ' / ' + string(mpf_decimal_alt(b2, 200)));
  mpf_set1(q);
  mpf_set1(t[1]);
  for m := 2 to N do begin
    for i := 1 to m - 1 do mpf_mul_int(t[i], i, t[i - 1]);
    mpf_set0(t[m - 1]);
    for i := m downto 2 do mpf_add(t[i], t[i - 2], t[i]);
    if m mod 2 = 0 then begin
      mpf_mul_int(q, 4, q);
      mpf_mul_int(t[0], m, b1);
      mpf_sub_int(q, 1, tmp);
      mpf_mul(q, tmp, b2);
      mpf_copy(b1, tmp);
      if m mod 4 = 0 then begin
        estr := ' = ';
        mpf_chs(b1, b1);
      end
      else estr := ' =  ';
      if mpf_is_lt(tmp, invE) and mpf_is_lt(b2, invE) then begin
        Mp_gcd(tmp, b2, d);
        mpf_div(b1, d, b1);
        mpf_div(b2, d, b2);
        memo1.lines.append('B' + inttostr(m) + estr + string(mpf_decimal_alt(b1, 200))
                                            + ' / ' + string(mpf_decimal_alt(b2, 200)));
      end
      else begin
        mpf_div(b1, b2, tmp);
        memo1.lines.append('B' + inttostr(m) + estr + string(mpf_decimal_alt(tmp, 200)));
      end;
    end;
  end;

  for i := 0 to N do mpf_clear(t[i]);
  mpf_clear(invE);
  mpf_clear5(q, b1, b2, d, tmp);
end;

//------------------------------------------------------------------------------

procedure TForm1.FormCreate(Sender: TObject);
var
  tmp: extended;
  MP_tmp: mp_float;
begin
  mpf_set_default_decprec(200);
  mpf_init(MP_EPSILON);
  mpf_init(MP_tmp);

  EPSILON := 1;
  repeat
    tmp := 1;
    EPSILON := EPSILON  / 2;
    tmp := tmp + EPSILON;
  until tmp = 1;
  EPSILON := EPSILON * 2;

  mpf_set1(MP_EPSILON);
  repeat
    mpf_set1(MP_tmp);
    mpf_div_int(MP_EPSILON, 2, MP_EPSILON);
    mpf_add(MP_tmp, MP_EPSILON, MP_tmp);
  until mpf_is1a(MP_tmp);
  mpf_mul_int(MP_EPSILON, 2, MP_EPSILON);

  memo1.Clear;
  memo1.Lines.Append('EPSIRON = ' + floatTostr(EPSILON));
  memo1.Lines.Append('MP_EPSIRON = ' + string(mpf_decimal_alt(MP_EPSILON, 200)));
  memo1.Lines.Append('MP_tmp = ' + string(mpf_decimal_alt(MP_tmp, 80)));

  mpf_clear(MP_tmp);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  mpf_clear(MP_EPSILON);
end;

end.
